;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;										;;
;;				Confetti				;;
;;				========				;;
;;										;;
;;			 By Forklift_Fred			;;
;;	 For SoCodor's Wednesday Workshop	;;
;;		#141 (05/03/08 - 12/03/08)		;;
;;										;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AppTitle "Confetti - Rectangle Challenge"

Graphics 640,480,32,2
SetBuffer BackBuffer()

Type rec
	Field x
	Field y
	Field width
	Field height
	Field red
	Field green
	Field blue
End Type

Global printx
Global printy
Global centerx
Global centery
Global printheight

hiscore=0

.start
SeedRnd MilliSecs()
speed=1000
nexttime=speed
level=1
score=0
gameover=False

ClsColor 0,0,0
Cls

Color 255,255,255
InitMyPrint 320,100,1,1,15
MyPrint "Confetti - Rectangle Challenge"
MyPrint "=============================="
MyPrint
MyPrint
MyPrint "Rectangles will appear randomly on the screen"
MyPrint "Point to them and they will disappear and score a point"
MyPrint "As the level progresses the rectangles will appear quicker"
MyPrint "If there are too many left when the level ends, it's game over!"
MyPrint
MyPrint "As you progress through the levels you will be presented with more rectangles"
MyPrint
MyPrint "The current Hiscore is "+hiscore
MyPrint
MyPrint "Click to start"

Flip

FlushKeys
FlushMouse
mouse=0
While Not KeyHit(1)
	mouse=GetMouse()
	If mouse Then Exit
Wend

If Not mouse Then End

starttime=MilliSecs()
timer=starttime
ClsColor Rnd(0,100),Rnd(0,100),Rnd(0,100)
While Not KeyHit(1)
	Cls
	timer=MilliSecs()-starttime
	If timer=>nexttime Then
		nexttime=timer+speed
		speed=speed-10
		If speed=0 Then
			speed=1000
			target=level*30
			level=level+1
			count=0
			For rec.rec=Each rec
				count=count+1
				Delete rec
			Next
			If count>1 Then
				score=score-count
				If count>target Then gameover=True
			End If
			Cls
			Text 320,200,"Minimum "+target+" Missed "+count,1,1
			If gameover Then
				Text 320,220,"Game over! Click to play again",1,1
			Else
				Text 320,220,"Level Complete. Click for Level "+level,1,1
			End If
			Text 320,260,"Score "+score,1,1
			Flip
			FlushKeys
			FlushMouse
			mouse=0
			While Not KeyHit(1)
				mouse=GetMouse()
				If mouse Then Exit
			Wend
			If Not mouse Then Exit
			If score>hiscore Then hiscore=score
			If gameover Then Goto start
			starttime=MilliSecs()
			timer=starttime
			nexttime=speed
			ClsColor Rnd(0,100),Rnd(0,100),Rnd(0,100)
		Else
			For n=1 To level
				rec.rec=New rec
				rec\width=Rnd(3,speed/10+30)
				rec\height=Rnd(3,speed/10+30)
				rec\x=Rnd(0,637-rec\width)
				rec\y=Rnd(0,477-rec\height)
				rec\red=Rnd(128,200)
				rec\green=Rnd(128,200)
				rec\blue=Rnd(128,200)
			Next
		End If
	End If
	For rec.rec=Each rec
		Color rec\red,rec\green,rec\blue
		Rect(rec\x,rec\y,rec\width,rec\height)
		If MouseX()=>rec\x And MouseX()<=rec\x+rec\width And MouseY()=>rec\y And MouseY()<=rec\y+rec\height Then
			Delete rec
			score=score+1
		End If
	Next
	Color 255,255,255
	Text 10,10,"Level: "+level
	Text 10,25,"Score: "+score
	Flip
Wend
Goto start

Function InitMyPrint(x,y,cx,cy,ph)
	printx=x
	printy=y
	centerx=cx
	centery=cy
	printheight=ph
End Function

Function MyPrint(txt$=" ")
	printy=printy+printheight
	Text printx,printy,txt$,centerx,centery
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D